#!/bin/sh
#
# Wired is developped and distributed under GPL Licence#
#
# The Software is provided to you AS IS and WITH ALL FAULTS. 
# Wired makes no representation and gives no warranty whatsoever, 
# whether express or implied, and without limitation, with regard to the quality, 
# safety, contents, performance, merchantability, non-infringement or suitability for 
# any particular or intended purpose of the Software found on the Wired web site. 
# In no event will Wired be liable for any direct, indirect, punitive, special, 
# incidental or consequential damages however they may arise and even if Wired has 
# been previously advised of the possibility of such damages.

echo 
echo "*********************************"
echo "*          Wired-libs           *"
echo "*    Thanks for using Wired     *"
echo "*                               *"
echo "*            v 0.2              *"
echo "*                               *"
echo "*      Make sure you have       *"
echo "*         sudo - gtk+2.x        *"
echo "*       alsa - pkg-config       *"
echo "*           wxGTK2.x            *"
echo "*  installed on your computer   *"
echo "*                               *"
echo "*********************************"
echo "*          Wired Team           *"
echo "*********************************"
echo 
echo ""
echo " Make sure you have root password !"
echo ""
echo ""
echo ""


##
## CONFIGURATION
## 

#setup directory prefix for libs
INSTALL_PREFIX="/usr/local"

#source subdirectory
SOURCE_SUBDIR="./src/"

#Configuration file for sudo
SUDO_FILE="/etc/sudoers"

DIR_SOUNDTOUCH="SoundTouch-1.3.0"
DIR_DSSI="dssi-0.9"
DIR_LADSPA="ladspa_sdk"
DIR_LIBSAMPLERATE="libsamplerate-0.1.2"
DIR_LIBSNDFILE="libsndfile-1.0.11"
DIR_PORTAUDIO="portaudio"

LADSPA_PATH=$INSTALL_PREFIX"/lib/ladspa"
DSSI_PATH=$INSTALL_PREFIX"/lib/dssi"

PWD=`pwd`

LOG_FILE="$PWD/install_wiredlibs.log"

date > $LOG_FILE

##
## INSTALL
##

# check for gcc

function check_gcc()
{
    if test -x /usr/bin/gcc ; then
	echo "gcc ... yes"
    else
	echo "gcc ... no"
	echo "Please install gcc and restart the install"
	exit
    fi
}

# When exit on error

function error()
{
    echo "ERROR"
    exit 2
}

# Installation of Wired-libs

#install soundtouch
function install_soundtouch()
{
    #install Soundtouch
    echo -n "Do you want to install $DIR_SOUNDTOUCH ? [yes/no] "
    read reponse
    if [ "$reponse" == yes ]; then
	echo ""
	echo "install Soundtouch"
	echo -n "processing : 0%"
	cd $DIR_SOUNDTOUCH >> $LOG_FILE
	./configure --prefix=$INSTALL_PREFIX >> $LOG_FILE 2>> $LOG_FILE
	echo -n "...30%"
	make all >> $LOG_FILE 2>> $LOG_FILE
	echo -n "...90%"
	sudo make install >> $LOG_FILE 2>> $LOG_FILE
	echo "...100%"
	echo "Installation complete !"
	cd ..
    else if [ "$reponse" == no ]; then
	echo "You don't want to install $DIR_SOUNDTOUCH."
    else
	echo "Please type yes or no"
	install_soundtouch
    fi
    fi
}

#install dssi
function	install_dssi()
{
    echo -n "Do you want to install $DIR_DSSI ? [yes/no] "
    read reponse
    if [ "$reponse" == yes ]; then
	echo ""
	echo "install dssi"
	echo -n "processing : 0%"
	cd $DIR_DSSI >> $LOG_FILE	
	make all >> $LOG_FILE 2>> $LOG_FILE
	echo -n "...90%"
	sudo make install >> $LOG_FILE 2>> $LOG_FILE
	export DSSI_PATH=$DSSI_PATH >> $LOG_FILE 2>> $LOG_FILE
	echo "...100%"
	echo "Installation complete !"
	cd ..
    else if [ "$reponse" == no ]; then
	echo "You don't want to install $DIR_DSSI."
    else
	echo "Please type yes or no"
	install_dssi
    fi
    fi
}

#install ladspa_sdk
function	install_ladspa()
{
    echo -n "Do you want to install $DIR_LADSPA ? [yes/no] "
    read reponse
    if [ "$reponse" == yes ]; then
	echo ""
	echo "install Ladspa"
	echo -n "processing : 0%"
	cd $DIR_LADSPA >> $LOG_FILE
	cd src >> $LOG_FILE
	echo -n "...5%"
	sud make install>> $LOG_FILE 2>> $LOG_FILE
	echo -n "...90%"
	export LADSPA_PATH=$LADSPA_PATH >> $LOG_FILE 2>> $LOG_FILE
	echo "...100%"
	echo "Installation complete !"
	cd ../..
    else if [ "$reponse" == no ]; then
	echo "You don't want to install $DIR_LADSPA."
    else
	echo "Please type yes or no"
	install_ladspa
    fi
    fi
}

#install libsamplerate
function	install_libsamplerate()
{
    echo -n "Do you want to install $DIR_LIBSAMPLERATE ? [yes/no] "
    read reponse
    if [ "$reponse" == yes ]; then
	echo ""
	echo "install libsamplerate"
	echo -n "processing : 0%"
	cd $DIR_LIBSAMPLERATE >> $LOG_FILE
	./configure --prefix=$INSTALL_PREFIX >> $LOG_FILE 2>> $LOG_FILE
	echo -n "...30%"
	make all >> $LOG_FILE 2>> $LOG_FILE
	echo -n "...90%"
	sudo make install >> $LOG_FILE 2>> $LOG_FILE
	echo "...100%"
	echo "Installation complete !"
	cd ..
    else if [ "$reponse" == no ]; then
	echo "You don't want to install libsamplerate."
    else
	echo "Please type yes or no"
	install_libsamplerate
    fi
    fi
}

#install libsndfile
function	install_libsndfile()
{
    echo -n "Do you want to install $DIR_LIBSNDFILE ? [yes/no] "
    read reponse
    if [ "$reponse" == yes ]; then
	echo ""
	echo "install libsndfile"
	echo -n "processing : 0%"
	cd $DIR_LIBSNDFILE >> $LOG_FILE
	./configure --prefix=$INSTALL_PREFIX >> $LOG_FILE 2>> $LOG_FILE
	echo -n "...30%"
	make all >> $LOG_FILE 2>> $LOG_FILE
	echo -n "...90%"
	sudo make install >> $LOG_FILE 2>> $LOG_FILE
	echo "...100%"
	echo "Installation complete !"
	cd ..
    else if [ "$reponse" == no ]; then
	echo "You don't want to install libsndfile."
    else
	echo "Please type yes or no"
	install_libsndfile
    fi
    fi
}

#install portaudio
function	install_portaudio()
{
    echo -n "Do you want to install $DIR_PORTAUDIO ? [yes/no] "
    read reponse
    if [ "$reponse" == yes ]; then
	echo ""
	echo "install Portaudio"
	echo -n "processing : 0%"
	cd $DIR_PORTAUDIO >> $LOG_FILE
	./configure --prefix=$INSTALL_PREFIX --with-alsa >> $LOG_FILE 2>> $LOG_FILE
	echo -n "...30%"
	make all >> $LOG_FILE 2>> $LOG_FILE
	echo -n "...90%"
	sudo make install >> $LOG_FILE 2>> $LOG_FILE
	echo "...100%"
	echo "Installation complete !"
	cd ..
    else if [ "$reponse" == no ]; then
	echo "You don't want to install Portaudio."
    else
	echo "Please type yes or no"
	install_portaudio
    fi
    fi
}

function install_libs()
{
	install_soundtouch
	install_dssi
	install_ladspa
	install_libsndfile
	install_libsamplerate
	install_portaudio
}

# installation script

check_gcc
cd $SOURCE_SUBDIR
install_libs
cd ..

echo ""
echo "Please let us know if you find any bugs"
echo "on wired forums at sourceforge.net"
echo ""
echo "Thanks for using Wired."
echo "--"
echo "www.sourceforge.net/projects/wired"

